/**
 * This file is part of OpenMediaVault-autoshutdown.
 *
 * @license   http://www.gnu.org/licenses/gpl.html GPL Version 3
 * @author    Marcel Beck <marcel.beck@mbeck.org>
 * @copyright Copyright (c) 2012 Marcel Beck
 *
 * OpenMediaVault is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * OpenMediaVault is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenMediaVault. If not, see <http://www.gnu.org/licenses/>.
 */
	// require("js/omv/NavigationPanel.js")
	// require("js/omv/data/DataProxy.js")
	// require("js/omv/FormPanelExt.js")
	// require("js/omv/form/PasswordField.js")
	// require("js/omv/form/SharedFolderComboBox.js")
	// require("js/omv/form/plugins/FieldInfo.js")

	// require("js/omv/module/autoshutdown/admin/dialog/ports.js")

	// require("js/omv/module/autoshutdown/navigation.js")
	// require("js/omv/module/autoshutdown/utils.js")

Ext.ns("OMV.Module.Services.Autoshutdown.Admin.Panel");

/**
 * @class OMV.Module.Services.Autoshutdown.Admin.Panel.Network
 * @derived OMV.FormPanelExt
 */
OMV.Module.Services.Autoshutdown.Admin.Panel.Network = function (config)
{
	var initialConfig = {
		rpcService  :"Autoshutdown",
		rpcGetMethod:"getNetwork",
		rpcSetMethod:"setNetwork"
	};
	Ext.apply(initialConfig, config);
	OMV.Module.Services.Autoshutdown.Admin.Panel.Network.superclass.constructor.call(
					this, initialConfig);
};
Ext.extend(OMV.Module.Services.Autoshutdown.Admin.Panel.Network, OMV.FormPanelExt, {
	getFormItems:function ()
	{
		return [
			{
				xtype   :"fieldset",
				title   :"Network settings",
				defaults:{
					labelSeparator:""
				},
				items   :[
					{
						xtype     :"textfield",
						name      :"range",
						fieldLabel:"Range",
						vtype     :"autoshutdown_range",
						value     :"2..254",
						plugins   :[ OMV.form.plugins.FieldInfo ],
						infoText  :"Define a range of IPs which should be scanned, "
										+ "via XXX.XXX.XXX.xxx last triple of IP address in a list. <br />"
										+ "The following scheme is mandatory v..v+m,w,x..x+n,y+o..y,z <br />"
										+ "  - define an ip range : <start>..<end> -> the two dots are mandatory <br />"
										+ "  - define a single ip : <ip> <br />"
										+ "  - all list entries are seperated by comma ',' <br />"
										+ "Please make sure to leave 1 and 255 out of the list !"
					},
					{
						xtype    :"button",
						id       :this.getId() + "-ports",
						hideLabel:false,
						fieldLabel:"Ports",
						text     :"Configure Ports",
						scope    :this,
						handler  :function ()
						{
							var wnd = new OMV.Module.Services.Autoshutdown.Admin.Dialog.Ports();
							wnd.show();
						},
						plugins   :[ OMV.form.plugins.FieldInfo ],
						infoText  :'<a href="http://en.wikipedia.org/wiki/List_of_TCP_and_UDP_port_numbers" target="_blank">List of Ports</a>'
					}
				]
			}
		];
	}
});

OMV.NavigationPanelMgr.registerPanel("services", "autoshutdown", {
	cls     :OMV.Module.Services.Autoshutdown.Admin.Panel.Network,
	title   :"Network",
	position:20
});